/** 
 * Class that simulates a crowd
 * @author Cassy Romano
 * @author Barb Ericson
 */
public class CrowdSimulation extends Simulation {
  
  /** the hunter */
  private NBDAgent hunter; // We'll need to get this later in CrowdAgent
  
  /** holds the frames */
  private FrameSequencer myFrames; // Need a separate one from Simulations
  
  /**
   * Method to get the hunter
   * @return the hunter
   */
  public NBDAgent getHunter() { return hunter; }
  
  /**
   * Set up the world 
   */
  public void setUp() {
    
    // ask the parent to set up the world
    super.setUp();
    
    // We'll need frames for the animation
    myFrames = new FrameSequencer("C:/dsbook/crowd/");
    myFrames.show();
    
    // create 100 dogs
    CrowdAgent doggie;
    for (int num = 0; num < 100; num++) {
      doggie = new CrowdAgent(getWorld(),this);}
    
    // And the big life-like dog
    hunter = new NBDAgent(getWorld(),this);
  }
  
  /**
   * Method to call at the end of a timestep
   * @param t the current timestep
   */
  public void endStep(int t) {
    
    // Do the normal file processing (if any)
    super.endStep(t);
    
    // But now, make a 640x480 frame, and copy
    // in pictures from all the agents
    Picture frame = new Picture(600,600);
    Agent drawMe = null;
    for (int index=0; index<this.getAgents().size(); index++) {
      drawMe = (Agent) this.getAgents().get(index);
      drawMe.getPicture().blueScreen(frame,drawMe.getXPos(),
                                     drawMe.getYPos());
    }
    myFrames.addFrame(frame);
  }
  
}
