import jm.music.data.*;
import jm.JMC;
import jm.util.*;
import jm.music.tools.*;

/**
 * Class that represents a multiple voice version
 * of Amazing Grace
 * @author Mark Guzdial
 * @author Barb Ericson
 */
public class MVAmazingGraceSong {
  
  /** the score for the song */
  private Score myScore = new Score("Amazing Grace");
  
  /**
   * Method to get the score
   * @return the score for this song
   */
  public Score getScore() {
    return myScore;
  }
  
  /**
   * Constructor to set up the song
   */
  public MVAmazingGraceSong() {
    myScore.setTimeSignature(3,4);
    
    double[] phrase1Data = {
      JMC.G4, JMC.QN,
      JMC.C5, JMC.HN, JMC.E5,JMC.EN, JMC.C5,JMC.EN,
      JMC.E5,JMC.HN,JMC.D5,JMC.QN,
      JMC.C5,JMC.HN,JMC.A4,JMC.QN,
      JMC.G4,JMC.HN,JMC.G4,JMC.EN,JMC.A4,JMC.EN,
      JMC.C5,JMC.HN,JMC.E5,JMC.EN,JMC.C5,JMC.EN,
      JMC.E5,JMC.HN,JMC.D5,JMC.EN,JMC.E5,JMC.EN,
      JMC.G5,JMC.DHN
    };
    double[] phrase2Data = {
      JMC.G5,JMC.HN,JMC.E5,JMC.EN,JMC.G5,JMC.EN,
      JMC.G5,JMC.HN,JMC.E5,JMC.EN,JMC.C5,JMC.EN,
      JMC.E5,JMC.HN,JMC.D5,JMC.QN,
      JMC.C5,JMC.HN,JMC.A4,JMC.QN,
      JMC.G4,JMC.HN,JMC.G4,JMC.EN,JMC.A4,JMC.EN,
      JMC.C5,JMC.HN,JMC.E5,JMC.EN,JMC.C5,JMC.EN,
      JMC.E5,JMC.HN,JMC.D5,JMC.QN,
      JMC.C5,JMC.DHN
    };
    
    //
    Phrase trumpetPhrase = new Phrase();
    trumpetPhrase.addNoteList(phrase1Data); // 22.0 beats long
    double endPhrase1 = trumpetPhrase.getEndTime();
    System.out.println("End of phrase1:"+endPhrase1);
    trumpetPhrase.addNoteList(phrase2Data);
    // create a new part and add the phrase to it
    Part part1 = new Part("TRUMPET PART", 
                          JMC.TRUMPET, 1);
    part1.addPhrase(trumpetPhrase);
    // add the part to the score
    myScore.addPart(part1);
    //
    Phrase flutePhrase = new Phrase(endPhrase1);
    flutePhrase.addNoteList(phrase1Data); // 22.0 beats long
    flutePhrase.addNoteList(phrase2Data); // optionally, remove this
    // create a new part and add the phrase to it
    Part part2 = new Part("FLUTE PART", 
                          JMC.FLUTE, 2);
    part2.addPhrase(flutePhrase);
    // add the part to the score
    myScore.addPart(part2);
    
  }
  
  /**
   * Method to show the song
   */
  public void showMe() {
    View.notate(myScore);
  }
  
}
