import java.util.*; // LinkedList representation

/**
 * Implements a simple queue using a list
 * @author Mark Guzdial
 * @author Barb Ericson
 */
public class QueueList {
  
  /** Where we'll store our elements */
  private LinkedList<Object> elements;
  
  /**
   * No argument constructor 
   */
  public QueueList() {
    elements = new LinkedList<Object>();
  }
  
  /// Methods
  
  /** 
   * Push an object onto the Queue 
   * @param element the element to add to the queue
   */
  public void push(Object element) {
    elements.addFirst(element);
  }
  
  /** 
   * Peek at, but don't remove, top (first) of queue 
   * @return the first element in the queue
   */
  public Object peek() {
    return elements.getLast();
  }
  
  /** 
   * Pop an object from the Queue 
   * @return the top object from the queue (and remove it)
   */
  public Object pop() {
    Object toReturn = this.peek();
    elements.removeLast();
    return toReturn;
  }
  
  /** 
   * Return the size of a queue 
   * @return the number of elements in the queue
   */
  public int size() { return elements.size(); }
  
  /** 
   * Empty?
   * @return true if no elements in the queue, else false
   */
  public boolean empty() {return this.size() == 0;}
  
  /** Main method for testing */
  public static void main (String[] args) {
    QueueList line = new QueueList();
    line.push("Fred");
    line.push("Mary");
    line.push("Jose");
    System.out.println(line.size());
    System.out.println(line.peek()); // without ending ';' prints the result
    System.out.println(line.pop());
    System.out.println(line.peek());
    System.out.println(line.pop());
    System.out.println(line.peek());
    System.out.println(line.pop());
    System.out.println(line.pop());
  }
}