/**
 * A class that demonstrates search algorithms
 * @author Mark Guzdial
 * @author Barb Ericson
 */
public class SearchMethods {
  
  /**
   * Implement a linear search through the array of strings
   * @param target the string to look for
   * @param strArray the array of strings to look in
   */
  public static String lfind(String target, String[] strArray) {
    for (int index=0; index < strArray.length; index++) {
      if (target.compareTo(strArray[index]) == 0) {
        return("Found it!"); 
      }
    }
    return("Not found");
  }
  
  /** 
   * Implement a simple binary search through the array 
   * of strings
   * @param target the string to look for
   * @param strArray the array of strings to look in
   */
  static public String find(String target, String[] strArray){
    int start = 0;
    int end = strArray.length - 1;
    int checkpoint = 0;
    
    while (start <= end) { //While there are more to search
      // find the middle
      checkpoint = (start+end)/2;
      System.out.println("Checking at: " + checkpoint + " start=" + 
                         start + " end=" + end);
      if ((checkpoint < 0) || (checkpoint > strArray.length)) {
        break;
      }
      if (target.compareTo(strArray[checkpoint]) == 0) {
        return "Found it!";
      }
      if (target.compareTo(strArray[checkpoint]) > 0) {
        start=checkpoint + 1;
      }
      if (target.compareTo(strArray[checkpoint]) < 0) {
        end=checkpoint - 1;
      }
    }
    return "Not found";
  }
  
  /** main for testing */
  static public void main(String[] args) {
    String[] searchMe = {"apple","bear","cat","dog","elephant"};
    
    System.out.println(find("apple",searchMe));
    System.out.println(find("cat",searchMe));
    System.out.println(find("giraffe",searchMe));
  }
  
}
